#include "Patterns.h"
#include <assert.h>

static PATTERN patterns[PATTERN_COUNT] = {
	{0, 0, 0, 0, 0, 0, 0, 0},
	{126, 129, 165, 129, 189, 153, 129, 126},
	{126, 255, 219, 255, 195, 231, 255, 126},
	{54, 127, 127, 127, 62, 28, 8, 0},
	{8, 28, 62, 127, 62, 28, 8, 0},
	{28, 62, 28, 127, 127, 73, 8, 62},
	{0, 8, 28, 62, 127, 62, 28, 62},
	{0, 0, 24, 60, 60, 24, 0, 0},
	{255, 255, 231, 195, 195, 231, 255, 255},
	{0, 60, 102, 66, 66, 102, 60, 0},
	{255, 195, 153, 189, 189, 153, 195, 255},
	{240, 224, 240, 190, 51, 51, 51, 30},
	{60, 102, 102, 102, 60, 24, 126, 24},
	{252, 204, 252, 12, 12, 14, 15, 7},
	{254, 198, 254, 198, 198, 230, 103, 3},
	{153, 90, 60, 231, 231, 60, 90, 153},
	{1, 7, 31, 127, 31, 7, 1, 0},
	{64, 112, 124, 127, 124, 112, 64, 0},
	{24, 60, 126, 24, 24, 126, 60, 24},
	{102, 102, 102, 102, 102, 0, 102, 0},
	{254, 219, 219, 222, 216, 216, 216, 0},
	{124, 198, 28, 54, 54, 28, 97, 63},
	{0, 0, 0, 0, 126, 126, 126, 0},
	{24, 60, 126, 24, 126, 60, 24, 255},
	{24, 60, 126, 24, 24, 24, 24, 0},
	{24, 24, 24, 24, 126, 60, 24, 0},
	{0, 24, 48, 127, 48, 24, 0, 0},
	{0, 12, 6, 127, 6, 12, 0, 0},
	{0, 0, 3, 3, 3, 127, 0, 0},
	{0, 36, 102, 255, 102, 36, 0, 0},
	{0, 24, 60, 126, 255, 255, 0, 0},
	{0, 255, 255, 126, 60, 24, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{24, 60, 60, 24, 24, 0, 24, 0},
	{54, 54, 54, 0, 0, 0, 0, 0},
	{54, 54, 127, 54, 127, 54, 54, 0},
	{24, 126, 3, 62, 96, 63, 24, 0},
	{0, 99, 51, 24, 12, 102, 99, 0},
	{28, 54, 28, 110, 59, 51, 110, 0},
	{12, 12, 6, 0, 0, 0, 0, 0},
	{24, 12, 6, 6, 6, 12, 24, 0},
	{6, 12, 24, 24, 24, 12, 6, 0},
	{0, 102, 60, 255, 60, 102, 0, 0},
	{0, 24, 24, 126, 24, 24, 0, 0},
	{0, 0, 0, 0, 0, 24, 24, 12},
	{0, 0, 0, 126, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 24, 24, 0},
	{96, 48, 24, 12, 6, 3, 1, 0},
	{62, 99, 107, 107, 107, 99, 62, 0},
	{12, 14, 12, 12, 12, 12, 63, 0},
	{30, 51, 48, 28, 6, 51, 63, 0},
	{30, 51, 48, 28, 48, 51, 30, 0},
	{56, 60, 54, 51, 127, 48, 120, 0},
	{63, 3, 31, 48, 48, 51, 30, 0},
	{28, 6, 3, 31, 51, 51, 30, 0},
	{63, 51, 48, 24, 12, 12, 12, 0},
	{30, 51, 51, 30, 51, 51, 30, 0},
	{30, 51, 51, 62, 48, 24, 14, 0},
	{0, 24, 24, 0, 0, 24, 24, 0},
	{0, 24, 24, 0, 0, 24, 24, 12},
	{24, 12, 6, 3, 6, 12, 24, 0},
	{0, 0, 126, 0, 126, 0, 0, 0},
	{6, 12, 24, 48, 24, 12, 6, 0},
	{60, 102, 48, 24, 24, 0, 24, 0},
	{62, 99, 123, 123, 59, 3, 62, 0},
	{12, 30, 51, 51, 63, 51, 51, 0},
	{63, 102, 102, 62, 102, 102, 63, 0},
	{60, 102, 3, 3, 3, 102, 60, 0},
	{31, 54, 102, 102, 102, 54, 31, 0},
	{127, 70, 22, 30, 22, 70, 127, 0},
	{127, 70, 22, 30, 22, 6, 15, 0},
	{60, 102, 3, 3, 115, 102, 92, 0},
	{51, 51, 51, 63, 51, 51, 51, 0},
	{30, 12, 12, 12, 12, 12, 30, 0},
	{120, 48, 48, 48, 51, 51, 30, 0},
	{103, 102, 54, 30, 54, 102, 103, 0},
	{15, 6, 6, 6, 70, 102, 127, 0},
	{99, 119, 127, 127, 107, 99, 99, 0},
	{99, 103, 111, 123, 115, 99, 99, 0},
	{28, 54, 99, 99, 99, 54, 28, 0},
	{63, 102, 102, 62, 6, 6, 15, 0},
	{62, 99, 99, 99, 107, 62, 112, 0},
	{63, 102, 102, 62, 54, 102, 103, 0},
	{62, 99, 7, 30, 112, 99, 62, 0},
	{63, 45, 12, 12, 12, 12, 30, 0},
	{51, 51, 51, 51, 51, 51, 63, 0},
	{51, 51, 51, 51, 51, 30, 12, 0},
	{99, 99, 99, 99, 107, 127, 54, 0},
	{99, 99, 54, 28, 54, 99, 99, 0},
	{51, 51, 51, 30, 12, 12, 30, 0},
	{127, 99, 49, 24, 76, 102, 127, 0},
	{30, 6, 6, 6, 6, 6, 30, 0},
	{3, 6, 12, 24, 48, 96, 64, 0},
	{30, 24, 24, 24, 24, 24, 30, 0},
	{8, 28, 54, 99, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 255},
	{12, 12, 24, 0, 0, 0, 0, 0},
	{0, 0, 30, 48, 62, 51, 110, 0},
	{7, 6, 6, 62, 102, 102, 59, 0},
	{0, 0, 30, 51, 3, 51, 30, 0},
	{56, 48, 48, 62, 51, 51, 110, 0},
	{0, 0, 30, 51, 63, 3, 30, 0},
	{28, 54, 38, 15, 6, 6, 15, 0},
	{0, 0, 110, 51, 51, 62, 48, 31},
	{7, 6, 54, 110, 102, 102, 103, 0},
	{12, 0, 14, 12, 12, 12, 30, 0},
	{48, 0, 56, 48, 48, 51, 51, 30},
	{7, 6, 102, 54, 30, 54, 103, 0},
	{14, 12, 12, 12, 12, 12, 30, 0},
	{0, 0, 51, 127, 127, 107, 107, 0},
	{0, 0, 29, 51, 51, 51, 51, 0},
	{0, 0, 30, 51, 51, 51, 30, 0},
	{0, 0, 59, 102, 102, 62, 6, 15},
	{0, 0, 110, 51, 51, 62, 48, 120},
	{0, 0, 59, 110, 70, 6, 15, 0},
	{0, 0, 62, 3, 14, 56, 31, 0},
	{8, 12, 63, 12, 12, 44, 24, 0},
	{0, 0, 51, 51, 51, 51, 110, 0},
	{0, 0, 51, 51, 51, 30, 12, 0},
	{0, 0, 99, 99, 107, 127, 54, 0},
	{0, 0, 99, 54, 28, 54, 99, 0},
	{0, 0, 51, 51, 51, 62, 48, 31},
	{0, 0, 63, 25, 12, 38, 63, 0},
	{56, 12, 12, 7, 12, 12, 56, 0},
	{24, 24, 24, 0, 24, 24, 24, 0},
	{7, 12, 12, 56, 12, 12, 7, 0},
	{110, 59, 0, 0, 0, 0, 0, 0},
	{0, 8, 28, 54, 99, 99, 127, 0},
	{62, 99, 3, 99, 62, 48, 96, 62},
	{0, 51, 0, 51, 51, 51, 110, 0},
	{56, 0, 30, 51, 63, 3, 30, 0},
	{126, 129, 60, 96, 124, 102, 220, 0},
	{51, 0, 30, 48, 62, 51, 110, 0},
	{7, 0, 30, 48, 62, 51, 110, 0},
	{12, 12, 30, 48, 62, 51, 110, 0},
	{0, 0, 62, 99, 3, 30, 48, 28},
	{126, 129, 60, 102, 126, 6, 60, 0},
	{51, 0, 30, 51, 63, 3, 30, 0},
	{7, 0, 30, 51, 63, 3, 30, 0},
	{51, 0, 14, 12, 12, 12, 30, 0},
	{62, 65, 28, 24, 24, 24, 60, 0},
	{7, 0, 14, 12, 12, 12, 30, 0},
	{99, 8, 62, 99, 127, 99, 99, 0},
	{12, 12, 0, 30, 51, 63, 51, 0},
	{56, 0, 63, 6, 30, 6, 63, 0},
	{0, 0, 254, 48, 254, 51, 254, 0},
	{124, 54, 51, 127, 51, 51, 115, 0},
	{30, 33, 0, 30, 51, 51, 30, 0},
	{0, 51, 0, 30, 51, 51, 30, 0},
	{0, 7, 0, 30, 51, 51, 30, 0},
	{30, 33, 0, 51, 51, 51, 110, 0},
	{0, 7, 0, 51, 51, 51, 110, 0},
	{0, 51, 0, 51, 51, 62, 48, 31},
	{195, 24, 60, 102, 102, 60, 24, 0},
	{51, 0, 51, 51, 51, 51, 30, 0},
	{24, 24, 126, 3, 3, 126, 24, 24},
	{28, 54, 38, 15, 6, 103, 63, 0},
	{51, 51, 30, 12, 63, 12, 63, 12},
	{31, 51, 51, 95, 99, 243, 99, 195},
	{112, 216, 24, 60, 24, 24, 27, 14},
	{56, 0, 30, 48, 62, 51, 110, 0},
	{28, 0, 14, 12, 12, 12, 30, 0},
	{0, 56, 0, 30, 51, 51, 30, 0},
	{0, 56, 0, 51, 51, 51, 110, 0},
	{0, 31, 0, 29, 51, 51, 51, 0},
	{63, 0, 51, 55, 63, 59, 51, 0},
	{60, 54, 54, 124, 0, 126, 0, 0},
	{28, 54, 54, 28, 0, 62, 0, 0},
	{24, 0, 24, 24, 12, 102, 60, 0},
	{0, 0, 0, 63, 3, 3, 0, 0},
	{0, 0, 0, 63, 48, 48, 0, 0},
	{99, 51, 27, 108, 214, 67, 33, 240},
	{195, 99, 51, 219, 236, 182, 243, 192},
	{24, 0, 24, 24, 60, 60, 24, 0},
	{0, 204, 102, 51, 102, 204, 0, 0},
	{0, 51, 102, 204, 102, 51, 0, 0},
	{68, 17, 68, 17, 68, 17, 68, 17},
	{170, 85, 170, 85, 170, 85, 170, 85},
	{187, 238, 187, 238, 187, 238, 187, 238},
	{24, 24, 24, 24, 24, 24, 24, 24},
	{24, 24, 24, 24, 31, 24, 24, 24},
	{24, 24, 31, 24, 31, 24, 24, 24},
	{108, 108, 108, 108, 111, 108, 108, 108},
	{0, 0, 0, 0, 127, 108, 108, 108},
	{0, 0, 31, 24, 31, 24, 24, 24},
	{108, 108, 111, 96, 111, 108, 108, 108},
	{108, 108, 108, 108, 108, 108, 108, 108},
	{0, 0, 127, 96, 111, 108, 108, 108},
	{108, 108, 111, 96, 127, 0, 0, 0},
	{108, 108, 108, 108, 127, 0, 0, 0},
	{24, 24, 31, 24, 31, 0, 0, 0},
	{0, 0, 0, 0, 31, 24, 24, 24},
	{24, 24, 24, 24, 248, 0, 0, 0},
	{24, 24, 24, 24, 255, 0, 0, 0},
	{0, 0, 0, 0, 255, 24, 24, 24},
	{24, 24, 24, 24, 248, 24, 24, 24},
	{0, 0, 0, 0, 255, 0, 0, 0},
	{24, 24, 24, 24, 255, 24, 24, 24},
	{24, 24, 248, 24, 248, 24, 24, 24},
	{108, 108, 108, 108, 236, 108, 108, 108},
	{108, 108, 236, 12, 252, 0, 0, 0},
	{0, 0, 252, 12, 236, 108, 108, 108},
	{108, 108, 239, 0, 255, 0, 0, 0},
	{0, 0, 255, 0, 239, 108, 108, 108},
	{108, 108, 236, 12, 236, 108, 108, 108},
	{0, 0, 255, 0, 255, 0, 0, 0},
	{108, 108, 239, 0, 239, 108, 108, 108},
	{24, 24, 255, 0, 255, 0, 0, 0},
	{108, 108, 108, 108, 255, 0, 0, 0},
	{0, 0, 255, 0, 255, 24, 24, 24},
	{0, 0, 0, 0, 255, 108, 108, 108},
	{108, 108, 108, 108, 252, 0, 0, 0},
	{24, 24, 248, 24, 248, 0, 0, 0},
	{0, 0, 248, 24, 248, 24, 24, 24},
	{0, 0, 0, 0, 252, 108, 108, 108},
	{108, 108, 108, 108, 255, 108, 108, 108},
	{24, 24, 255, 24, 255, 24, 24, 24},
	{24, 24, 24, 24, 31, 0, 0, 0},
	{0, 0, 0, 0, 248, 24, 24, 24},
	{255, 255, 255, 255, 255, 255, 255, 255},
	{0, 0, 0, 0, 255, 255, 255, 255},
	{15, 15, 15, 15, 15, 15, 15, 15},
	{240, 240, 240, 240, 240, 240, 240, 240},
	{255, 255, 255, 255, 0, 0, 0, 0},
	{0, 0, 110, 59, 19, 59, 110, 0},
	{62, 99, 99, 51, 99, 195, 115, 0},
	{0, 63, 51, 3, 3, 3, 3, 0},
	{0, 0, 127, 54, 54, 54, 54, 0},
	{63, 51, 6, 12, 6, 51, 63, 0},
	{0, 0, 126, 27, 27, 27, 14, 0},
	{0, 102, 102, 102, 102, 62, 6, 3},
	{0, 110, 59, 24, 24, 24, 24, 0},
	{63, 12, 30, 51, 51, 30, 12, 63},
	{28, 54, 99, 127, 99, 54, 28, 0},
	{28, 54, 99, 99, 54, 54, 119, 0},
	{56, 12, 24, 62, 51, 51, 30, 0},
	{0, 0, 126, 219, 219, 126, 0, 0},
	{96, 48, 126, 219, 219, 126, 6, 3},
	{28, 6, 3, 31, 3, 6, 28, 0},
	{30, 51, 51, 51, 51, 51, 51, 0},
	{0, 126, 0, 126, 0, 126, 0, 0},
	{24, 24, 126, 24, 24, 0, 126, 0},
	{6, 12, 24, 12, 6, 0, 63, 0},
	{24, 12, 6, 12, 24, 0, 63, 0},
	{112, 216, 216, 24, 24, 24, 24, 24},
	{24, 24, 24, 24, 24, 27, 27, 14},
	{24, 24, 0, 126, 0, 24, 24, 0},
	{0, 110, 59, 0, 110, 59, 0, 0},
	{28, 54, 54, 28, 0, 0, 0, 0},
	{0, 0, 0, 24, 24, 0, 0, 0},
	{0, 0, 0, 0, 24, 0, 0, 0},
	{240, 48, 48, 48, 55, 54, 60, 56},
	{26, 54, 54, 54, 54, 0, 0, 0},
	{14, 25, 12, 6, 31, 0, 0, 0},
	{0, 0, 60, 60, 60, 60, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	//PATTERN_FIELD
	{
		0x00,0x22,0x00,0x88,0x00,0x22,0x00,0x88
	},
	//PATTERN_TREE
	{
		0x10,0x10,0x38,0x38,0x7C,0x7C,0xFE,0x10
	},
	//PATTERN_TAGON
	{
		0x1C,0x1C,0x08,0x3E,0x5D,0x1C,0x14,0x14
	},
	//"solid": 
	{ 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
	//"box"
	{ 0xFF, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xFF},
	//"maze0" : 
	{0, 0, 0, 0x18, 0x18, 0, 0, 0},
	//"maze1" : 
	{0x18, 0x18, 0x18, 0x18, 0x18, 0, 0, 0},
	//"maze2" : 
	{0, 0, 0, 0xF8, 0xF8, 0, 0, 0},
	//"maze3" : 
	{0x18, 0x18, 0x18, 0xF8, 0xF8, 0, 0, 0},
	//"maze4" : 
	{0, 0, 0, 0x18, 0x18, 0x18, 0x18, 0x18},
	//"maze5" : 
	{0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18},
	//"maze6" : 
	{0, 0, 0, 0xF8, 0xF8, 0x18, 0x18, 0x18},
	//"maze7" : 
	{0x18, 0x18, 0x18, 0xF8, 0xF8, 0x18, 0x18, 0x18},
	//"maze8" : 
	{0, 0, 0, 0x1F, 0x1F, 0, 0, 0},
	//"maze9" : 
	{0x18, 0x18, 0x18, 0x1F, 0x1F, 0, 0, 0},
	//"maze10" : 
	{0, 0, 0, 0xFF, 0xFF, 0, 0, 0},
	//"maze11" : 
	{0x18, 0x18, 0x18, 0xFF, 0xFF, 0, 0, 0},
	//"maze12" : 
	{0, 0, 0, 0x1F, 0x1F, 0x18, 0x18, 0x18},
	//"maze13" : 
	{0x18, 0x18, 0x18, 0x1F, 0x1F, 0x18, 0x18, 0x18},
	//"maze14" : 
	{0, 0, 0, 0xFF, 0xFF, 0x18, 0x18, 0x18},
	//"maze15" : 
	{0x18, 0x18, 0x18, 0xFF, 0xFF, 0x18, 0x18, 0x18},
	//"empty" : 
	{0, 0, 0, 0, 0, 0, 0, 0},
	//"ui_left" : 
	{0x3E, 0x41, 0xc9, 0xc5, 0xc9, 0xc1, 0xfe, 0x7c},
	//"ui_left_down" : 
	{0, 0x7c, 0x82, 0x92, 0x8a, 0x92, 0x82, 0x7c},
	//"ui_right" : 
	{0x3E, 0x41, 0xc9, 0xd1, 0xc9, 0xc1, 0xfe, 0x7c},
	//"ui_right_down" : 
	{0, 0x7c, 0x82, 0x92, 0xa2, 0x92, 0x82, 0x7c},
	//"ui_up" : 
	{0x3E, 0x41, 0xc9, 0xd5, 0xc1, 0xc1, 0xfe, 0x7c},
	//"ui_up_down" : 
	{0, 0x7c, 0x82, 0x92, 0xaa, 0x82, 0x82, 0x7c},
	//"ui_down" : 
	{0x3E, 0x41, 0xc1, 0xd5, 0xc9, 0xc1, 0xfe, 0x7c},
	//"ui_down_down" : 
	{0, 0x7c, 0x82, 0x82, 0xaa, 0x92, 0x82, 0x7c},
	//"pin" : 
	{0x60, 0x70, 0x3E, 0x1E, 0x1c, 0x1a, 0x01, 0},
	//"energy" : 
	{0x78, 0x3c, 0x1E, 0x3f, 0x18, 0x0c, 0x04, 0x02},
	//"cursor" : 
	{0, 0, 0, 0, 0x08, 0, 0, 0},
	//"house" : 
	{0x08, 0x1c, 0x3E, 0x7f, 0x3E, 0x36, 0x36, 0},
	//"door" : 
	{0x18, 0x3c, 0x7E, 0x7E, 0x7E, 0x6e, 0x7E, 0x7E},
	//"wall" : 
	{0, 0xfe, 0xfe, 0xfe, 0, 0xef, 0xef, 0xef},
	//"deadtagon" : 
	{0x14, 0x14, 0x1c, 0x6d, 0x3E, 0x08, 0x1c, 0x1c},
	//"sapling" : 
	{0, 0x08, 0x08, 0x1c, 0x08, 0x3E, 0x08, 0},
	//"acorn" : 
	{0, 0, 0x10, 0x08, 0x3E, 0x1c, 0x08, 0},
	//"bush" : 
	{0, 0x3c, 0x6e, 0xfb, 0xdf, 0x7E, 0x18, 0x18},
	//"berries" : 
	{0, 0, 0x10, 0x04, 0x20, 0, 0, 0},
	//"key" : 
	{0, 0x1c, 0x14, 0x1c, 0x08, 0x0c, 0x0c, 0},
	//"rock" : 
	{0, 0, 0, 0x34, 0x7E, 0x7E, 0x3E, 0},
	//"lefthand" : 
	{0x38, 0x3c, 0x3c, 0xbc, 0xfc, 0x7c, 0x3c, 0},
	//"righthand" : 
	{0x1c, 0x3c, 0x3c, 0x3d, 0x3f, 0x3E, 0x3c, 0},
	//"log" : 
	{0, 0, 0x7f, 0x3E, 0x7f, 0, 0, 0},
	//"stone" : 
	{0, 0, 0x38, 0x3c, 0x3c, 0x1c, 0, 0},
	//"axe" : 
	{0x12, 0x16, 0x1E, 0x1E, 0x16, 0x12, 0x10, 0x10},
	//"pickaxe" : 
	{0x3E, 0x49, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08},
	//"shovel" : 
	{0x08, 0x08, 0x08, 0x08, 0x08, 0x3E, 0x3E, 0x1c},
	//"hammer" : 
	{0x3E, 0x3E, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08},
	//"hoe" : 
	{0x0e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08},
	//"berryseed" : 
	{0, 0, 0, 0x08, 0, 0, 0, 0},
	//"pile" : 
	{0, 0, 0, 0x14, 0x2a, 0x55, 0, 0},
	//"rabbit" : 
	{0, 0x04, 0x04, 0x07, 0x7f, 0xfc, 0x66, 0},
	//"deadrabbit" : 
	{0, 0x66, 0xfc, 0x7f, 0x07, 0x04, 0x04, 0},
	//"hole" : 
	{0, 0, 0x18, 0x3c, 0x3c, 0x18, 0, 0},
	//"fire" : 
	{0x10, 0x18, 0x0c, 0x1c, 0x3E, 0x3E, 0x1c, 0},
	//"trap" : 
	{0, 0, 0x55, 0x55, 0x55, 0x7f, 0, 0},
	//"knife" : 
	{0, 0x10, 0x18, 0x18, 0x18, 0x10, 0x10, 0},
	//"pelt" : 
	{0x18, 0x7E, 0x3c, 0x3c, 0x3c, 0x3c, 0x7E, 0x42},
	//"meat" : 
	{0, 0x18, 0x3c, 0x3c, 0x3c, 0x3c, 0x18, 0},
	//PATTERN_SELECTOR
	{0xc3,0x81,0,0,0,0,0x81,0xc3},
	//PATTERN_SPEAR
	{0x70,0x60,0x50,0x08,0x04,0x02,0x01,0},
	//PATTERN_FISH
	{0,0,0x5e,0x7f,0x5e,0,0,0},
	//PATTERN_STOMACH
	{0x02,0x3e,0x78,0x78,0x3e,0x3f,0x01,0x00},
	//PATTERN_EYE,
	{0x00,0x1c,0x36,0x6b,0x36,0x1c,0x00,0x00},
	//PATTERN_MOUTH,
	{ 0x00,0x00,0x00,0x41,0x3e,0x1c,0x00,0x00 }
};

PATTERN* Patterns_getPattern(PATTERNTYPE pattern)
{
	assert(pattern >= PATTERN_FIRST && pattern < PATTERN_COUNT);
	return &(patterns[pattern]);
}

